package com.brilliance.isc.funds.fttpcm.service;

import com.brilliance.isc.bo.Bch;
import com.brilliance.isc.bo.Ftd;
import com.brilliance.isc.bo.Pta;
import com.brilliance.isc.bo.model.Ftacbs;
import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.api.bch.service.BchService;
import com.brilliance.isc.common.cache.pta.PtaCacheService;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.contants.CommonContants;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.transaction.help.TransactionHelpService;
import com.brilliance.isc.common.transaction.help.TransactionServiceSet;
import com.brilliance.isc.common.trnmod.service.TrnmodService;
import com.brilliance.isc.common.trnmod.vo.TrnmodVo;
import com.brilliance.isc.common.util.I18nUtil;import com.brilliance.isc.common.util.StringUtils;
import com.brilliance.isc.common.vo.BizAmdInfoVo;
import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.funds.bo.funds.FttpcmStoreBo;
import com.brilliance.isc.funds.fttpcm.check.FttpcmValidator;
import com.brilliance.isc.funds.vo.funds.FttpcmStoreVo;
;import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Dates;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.Map;
import java.util.Objects;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;


@Service("fttpcm.transaction")
public class FttpcmTransactionServiceImpl extends AbstractTransactionService<FttpcmStoreBo> {
        @Autowired
        private PtaCacheService ptaCacheService;
        @Resource
        private FttpcmValidator fttpcmValidator;
        @Resource
        private FtToolComponent ftToolComponent;
        @Resource
        private BchService bchService;
         @Resource
         private XrtmodService xrtmodService;
         @Resource
         private SysmodService sysmodService;
         @Resource
         private CbsmodService cbsmodService;
         @Resource
         private TransactionHelpService transactionHelpService;
         @Resource
         private TrnmodService trnmodService;
         @Resource
         private SettleContext settleContext;
//         @Resource
//         private FttpService fttpService;

    @PostConstruct
    public void regisertService() {
        serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");

    }
    @Override
    protected void txnSave(FttpcmStoreBo transactionVo){
        ruleMtabutSavN500(transactionVo);
    }

    public void ruleMtabutSavN500(FttpcmStoreBo bo) {
       TrnmodVo trnmodVo = transactionHelpService.getTransactionStoreSet().getTrnmodVo();
       Ftdgrp ftdgrp = bo.getFtdgrp();
       ftToolComponent.getref(ftdgrp);
       ftToolComponent.sav(ftdgrp);
       // 2. Build Transaction from FTDGRP
       trnmodService.trnSetFromContract(trnmodVo);
       cbsSav(bo, trnmodVo);
    }
     /**
     *   source:fttpcm.0003.script
     */
     public void cbsSav(FttpcmStoreBo transactionVo, TrnmodVo trnmodVo){
         //取得上下文
         cbsmodService.cbsTrnSetNew("TRN", trnmodVo.getTrn().getInr());
         Ftacbs cbs = transactionVo.getFtdgrp().getCbs();
         String trninr = transactionHelpService.getTrninr();

    	 trnmodService.cbsTrnStore("MAXAMT","AMT1",Dates.today(),cbs.getMax().getCur(),cbs.getMax().getAmt(),I18nUtil.getMessage("funds_fttpcm_000000"),transactionVo.getFtdgrp().getRec(), trninr);
    	 trnmodService.cbsTrnStore("UTLAMT","AMT1",Dates.today(),cbs.getMax().getCur(),cbs.getMax().getAmt(),I18nUtil.getMessage("funds_fttpcm_000000"),transactionVo.getFtdgrp().getRec(), trninr);
    	 trnmodService.cbsTrnStore("OPNAMT","AMT1",Dates.today(),cbs.getMax().getCur(),cbs.getMax().getAmt(),I18nUtil.getMessage("funds_fttpcm_000000"),transactionVo.getFtdgrp().getRec(), trninr);

        //trnmodService.troCommit(trnmodVo,);

    }
    @Override
    public void beforeSave(FttpcmStoreBo transactionVo) {
        transactionVo.reset();
        Ftdgrp ftdgrp = transactionVo.getFtdgrp();

        TransactionServiceSet transactionServiceSet = transactionHelpService.getTransactionStoreSet();
        transactionServiceSet.setRec(ftdgrp.getRec());
        transactionServiceSet.setBlk(ftdgrp.getBlk());
        transactionServiceSet.setTransactionVo(transactionVo);

        ftToolComponent.collectCbsMap(transactionServiceSet, "", ftdgrp.getCbs(), "max");
        ftToolComponent.collectPtsList(transactionServiceSet, ftdgrp, null);
        settleContext.loadSettleSession(transactionVo.getTransName(), transactionVo.getUserId(), buildBizInfo(transactionVo), transactionServiceSet.getPtsList());
    }
    @Override
    protected Map<String, String> txnCheck(FttpcmStoreBo transactionVo) {
         return fttpcmValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FttpcmStoreBo transactionVo) {
           FtdBizInfoVo bizInfoVo = new FtdBizInfoVo();
           bizInfoVo.setObjtyp("FTD");
           Ftd rec = transactionVo.getFtdgrp().getRec();
           bizInfoVo.setObjinr(rec.getInr());
           bizInfoVo.setOwnref(rec.getOwnref());
           bizInfoVo.setFttyp(rec.getFttyp());
           bizInfoVo.setRat(rec.getRat());
           bizInfoVo.setBranchInr(rec.getBranchinr());
           bizInfoVo.setEtyextkey(rec.getEtyextkey());
           bizInfoVo.setAmt(rec.getAmt());
           bizInfoVo.setBranchInr(rec.getBranchinr());
           return bizInfoVo;
    }
    @Override
    protected void updateBizInfoVo(BizInfoVo bizInfoVo, FttpcmStoreBo transactionVo) {
        bizInfoVo.setObjinr(transactionVo.getFtdgrp().getRec().getInr());
    }

    @Override
    protected BizAmdInfoVo buildBizAmdInfo(FttpcmStoreBo transactionVo) {
        return null;
    }

    public String getRef(FttpcmStoreVo fttpcmStoreVo) {
        fttpcmStoreVo.reset();
        PtsptaVo ptsptaVo1 = fttpcmStoreVo.getFtdgrp().getBen();
        if (ptsptaVo1 == null || StringUtils.isEmpty(ptsptaVo1.getPtainr())) {
            return NULLSTR;
        }
         PtsptaVo ptsptaVo2 = fttpcmStoreVo.getFtdgrp().getTro();
         if (ptsptaVo2 == null || StringUtils.isEmpty(ptsptaVo2.getPtainr())) {
            return NULLSTR;
         }
         PtsptaVo ptsptaVo3 = fttpcmStoreVo.getFtdgrp().getTri();
         if (ptsptaVo3 == null || StringUtils.isEmpty(ptsptaVo3.getPtainr())) {
             return NULLSTR;
         }
          Pta pta = ptaCacheService.getPtaByInr(ptsptaVo2.getPtainr());
          Bch wrkbch = new Bch();
          wrkbch.setInr(pta.getBranchinr());
          wrkbch = bchService.selectByPrimaryKey(wrkbch);
          if (Objects.isNull(wrkbch)) {
              return NULLSTR;
          }
        SettleContext.getUserSession().setWrkbch( SettleContext.getUserSession().getBch());
        Ftdgrp ftdgrp = fttpcmStoreVo.getFtdgrp();
        ftToolComponent.getref(ftdgrp);
        return ftdgrp.getRec().getOwnref();

    }

       @Override
        public FttpcmStoreBo init(FttpcmStoreBo fttpcmStoreBo) {
            fttpcmStoreBo.reset();
            init950(fttpcmStoreBo);
            init1000(fttpcmStoreBo);
            return fttpcmStoreBo;
        }

        /**
         * source:fxtfop.0001.script
         */
        public void init1000(FttpcmStoreBo bo) {

           // bo.getFtdgrp().getCbs().getMax().setCur(xrtmodService.sysiso());

            if (bo.getFtdgrp().getRec().getOpndat() ==null ){
                bo.getFtdgrp().getRec().setOpndat(Dates.today());
            }

            if (bo.getFtdgrp().getRec().getValdat() ==null ){
                bo.getFtdgrp().getRec().setValdat(Dates.today());
            }
            bo.getFtdgrp().getRec().setFttyp("PT");
            String extkey = SettleContext.getUserSession().getUsr().getExtkey();
            bo.getFtdgrp().getRec().setUsr(extkey);
        }

        private void init950(FttpcmStoreBo fttpcmStoreBo) {

        }
}
