package com.brilliance.isc.funds.fxtlcm.register.settle;

import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: FxtlcmSettleRegister
 * @description: 结售汇平盘确认 Fxtlcm 账务注册
 * @author: Lenovo
 * @create: 2024-10-14 15:33
 */
@Component("fxtlcm.settleRegister")
public class FxtlcmSettleRegister implements ISettleRegister {

    @Autowired
    private PtsptaToolComponent ptsptaToolComponent;
    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();
        BigDecimal maxAmt = BigDecimal.ZERO;
        BigDecimal nom1Amt = BigDecimal.ZERO;
        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
        }
        String nom1Cur = NULLSTR;
        if (setmodVo.getCbsMap().get("NOM1") != null) {
            nom1Amt = setmodVo.getCbsMap().get("NOM1").getAmt();
            nom1Cur = setmodVo.getCbsMap().get("NOM1").getCur();
        }
        setmodVo.setDocamt(maxAmt);
        setmodVo.setOpnamt(maxAmt);
        SetglgVo setglg = setmodVo.getSetglg();
        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"TRN" );
        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"SET" );
        //!==============================================
        //!卖出：D:139(CNY) C:4250305(CNY)
        //!        D:4250305外币 C:114(116)外币
        //!----------------------------------------------
        //!买入：D:139外币 C:4250305外币
        //!        D:4250305(CNY) C:262(CNY)-通过大额付出
        //!==============================================
        String act1 = NULLSTR;
        String ddtKey = NULLSTR;
        String act4 = NULLSTR;
        String cbtKey = NULLSTR;
        String dbtKey1 = NULLSTR;
        String act5 = NULLSTR;
        String cbtKey1 = NULLSTR;
        String dbtKey = NULLSTR;
        String acctyp = NULLSTR;
        String acc = NULLSTR;
        String cdtKey = NULLSTR;
        if( ! MdaUtils.isEmpty(nom1Amt) && ! MdaUtils.isEmpty(rec.getFxtyp()) )
        {
            //#买入确认
            if( MdaUtils.compareTo(Strings.mid(rec.getFxtyp(),2,1),"B") == 0 )
            {
                //D:139外币
                /**
                 $Act1 = SETMOD\\GLEMOD.GetAvailAcc ( "FT-FXR", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )
                 **/
                act1 = glemodService.getAvailAcc ( "FT-FCR", setmodVo.getDoccur(), "", setmodVo.getSetamt() );
                ddtKey = setglgService.setglgAddAmount (setmodVo.getSetglg(), "TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt(), "", "FTD", "C", act1, "" );
                //C:262(CNY)
                setglgService.setglgAddAmtFldAccCur ( setmodVo.getSetglg(),"SET", ddtKey, nom1Cur );
                setglgService.setglgAddAmtFldExtRat ( setmodVo.getSetglg(),"SET", ddtKey, BigDecimal.valueOf(1.00), rec.getRat() );
                act4 = glemodService.getAvailAcc ( "FT-FXP", "CNY", "", setmodVo.getDocamt() );
                cbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "APL", setmodVo.getDoccur(),setmodVo.getDocamt().negate(), "SET", "FTC", "F", act4, "SET" );
                /**
                 $dbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "APL", FXDGRP\\CBS\\NOM1\\CUR, -FXDGRP\\CBS\\NOM1\\AMT, "SET", "FTC", "F", $Act4, "SET" )

                 **/
                setglgService.setglgAddAmtFldAccCur ( setmodVo.getSetglg(),"SET", cbtKey, nom1Cur);
                setglgService.setglgAddAmtFldExtRat ( setmodVo.getSetglg(),"SET", cbtKey, BigDecimal.valueOf(1.00), rec.getRat() );
                //##!201901517
                /**
                 $DbtKey1 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", SETMOD\\DOCCUR, SETMOD\\SETAMT, "SET", "DTD", "A", $Act4, "" )
                 \\SETMOD\\SETGLG.SetglgAddAmtFldAccCur ( "TRN", $DbtKey1, FXDGRP\\CBS\\NOM1\\CUR )
                 \\SETMOD\\SETGLG.SetglgAddAmtFldExtRat ( "TRN", $DbtKey1, 1.00, FXDGRP\\REC\\RAT )
                 $CbtKey1 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "", "DTC", "A", "6799901262116000010054", "" )
                 \\SETMOD\\SETGLG.SetglgAddAmtFldAccCur ( "TRN", $CbtKey1, FXDGRP\\CBS\\NOM1\\CUR )
                 \\SETMOD\\SETGLG.SetglgAddAmtFldExtRat ( "TRN", $CbtKey1, 1.00, FXDGRP\\REC\\RAT )

                 **/
                dbtKey1 = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "OWN", nom1Cur, nom1Amt, "", "DTD", "F", act4, "" );
                act5 = glemodService.getAvailAcc ( "RP-HHP", "CNY", "",  setmodVo.getDocamt() );
                cbtKey1 = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "OWN",nom1Cur, nom1Amt.negate(), "", "DTC", "F", act5, "" );
                //425科目账号自动补
                /**
                 #C:4250305外币
                 $Act2 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-SLQ", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )
                 $CbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "APL", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "", "FXC", "C", $Act2, "" )
                 #D:4250305(CNY)
                 $Act3 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-SLQ", "CNY", "", self, SETMOD\\SETAMT )
                 $DdtKey = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "APL", SETMOD\\DOCCUR, SETMOD\\SETAMT, "SET", "FXD", "F", $Act3, "SET" )

                 **/
            }
            else
            {
                //#卖出确认
                //D:139(CNY)
                act1 = glemodService.getAvailAcc ( "FT-FCR", "CNY", "",  setmodVo.getDocamt() );
                dbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "APL", setmodVo.getDoccur(), setmodVo.getDocamt(), "SET", "FTD", "F", act1, "SET" );
                /**
                 # cz modify 增加中间中间账户
                 $Act4 = SETMOD\\GLEMOD.GetAvailAcc ( "FT-FXP", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )
                 $CbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "OWN", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "SET", "FTC", "F", $Act4, "SET" )
                 #C:4250305(CNY)
                 $Act2 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-SLQ", "CNY", "", self, SETMOD\\SETAMT )
                 $CbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "APL", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "SET", "FXD", "F", $Act2, "SET" )
                 #D:4250305外币
                 $Act3 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-SLQ", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )
                 $DbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "APL", SETMOD\\DOCCUR, -SETMOD\\SETAMT, "", "FXC", "C", $Act3, "" )

                 **/
                //C:114(116)外币
                //如果ACT未赋值，则APL为我行的账户行
                PtsptaVo act = ptsptaToolComponent.getPtsFromListByRol(setmodVo.getPtsList(),"ACT");
                PtsptaVo apl = ptsptaToolComponent.getPtsFromListByRol(setmodVo.getPtsList(),"APL");
                if( ptsptaToolComponent.ptsIsRolSet(act) )
                {
                    if( "CN".equals(act.getAdr().getLoccty()) )
                    {
                        acctyp = "DB-CLR";
                        acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), act.getPts().getPtyinr(), setmodVo.getDocamt() );
                        cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt().negate(), "", "DBC", "C", acc, "" );
                    }
                    else
                    {
                        acctyp = "DB-FOG";
                        acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), act.getPts().getPtyinr(), setmodVo.getDocamt() );
                        cdtKey = setglgService.setglgAddAmount (setmodVo.getSetglg(), "TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt().negate(), "", "PAC", "C", acc, "" );
                        //这个地方的PAC怀疑是BUG，应该是DBC（问题1）
                    }
                }
                else
                {
                    if( "CN".equals(apl.getAdr().getLoccty()) )
                    {
                        acctyp = "DB-CLR";
                        acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), apl.getPts().getPtyinr(), setmodVo.getDocamt() );
                        cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt().negate(), "", "DBC", "C", acc, "" );
                    }
                    else
                    {
                        acctyp = "DB-FOG";
                        acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), apl.getPts().getPtyinr(),  setmodVo.getDocamt() );
                        cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "APL", setmodVo.getDoccur(), setmodVo.getDocamt().negate(), "", "PAC", "C", acc, "" );
                    }
                }
                setglgService.setglgAddAmtFldAccCur ( setmodVo.getSetglg(),"SET", dbtKey, nom1Cur );
                setglgService.setglgAddAmtFldExtRat (  setmodVo.getSetglg(),"SET", dbtKey, BigDecimal.valueOf(1.00), rec.getRat() );
                /**
                 #!20190518迁移至销账交易
                 $DbtKey1 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", FXDGRP\\CBS\\NOM1\\CUR, FXDGRP\\CBS\\NOM1\\AMT, "", "DTC", "F", FXTP.getAccountByEntity, "SET" )
                 #  $Act4 = SETMOD\\GLEMOD.GetAvailAcc ( "FT-FXP", "CNY", "", self, SETMOD\\SETAMT )
                 $CbtKey1 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", FXDGRP\\CBS\\NOM1\\CUR, -FXDGRP\\CBS\\NOM1\\AMT, "", "DTD", "F", $Act1, "" )
                 $Act4 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-SLQ", "CNY", "", self, SETMOD\\SETAMT )
                 $DbtKey2 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", FXDGRP\\CBS\\NOM1\\CUR, FXDGRP\\CBS\\NOM1\\AMT, "", "FTC", "F", $Act4, "" )
                 $Act5 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-ZJJ", "CNY", "", self, SETMOD\\SETAMT )
                 $CbtKey2 = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "OWN", "CNY", -FXDGRP\\CBS\\NOM1\\AMT, "", "RPD", "C", $Act5, "" )
                 {
                 $Act6 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-UTL", "CNY", "", self, SETMOD\\SETAMT )
                 $CbtKey2 = SETMOD\\SETGLG.SetglgAddAmount ( "SET", "APL", "CNY", FXDGRP\\CBS\\NOM1\\AMT, "", "RPC", "C", $Act6, "" )

                 **/
            }
        }
        //this.getSetmod().setglgAllValDat ( this.getFxdgrp().getRec().getValdat(), "D" );
    }
}
