package com.brilliance.isc.funds.fxtsqo.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.fxtsqo.service.FxtsqoTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FxtsqoStructMapper;
import com.brilliance.isc.funds.vo.funds.FxtsqoStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FxtsqoResource
 * @description: 即期结售汇报价 Fxtsqo 请求入口
 * @author: huangshunlin
 * @create: 2024-10-18 15:34
 */
@RestController
@RequestMapping("/fxtsqo")
@Api("即期结售汇报价")
public class FxtsqoResource extends AbstractTransactionController<FxtsqoStoreVo> {

    @Resource
    private FxtsqoStructMapper fxtsqoStructMapper;

    public IStructMapper getStructMapper() {
        return fxtsqoStructMapper;
    }

    @Resource(name = "fxtsqo.transaction")
    FxtsqoTransactionServiceImpl fxtsqoTransactionService;

    @Autowired
    private SettleContext settleContext;


}
